﻿using AsReaderP3xUAndroidSDK;
using System.Collections;
using Com.Asreader.P3xu;
using Com.Asreader.P3xu.Rfid.Event;
using Com.Asreader.P3xu.Rfid.Type;
using Com.Asreader.P3xu.Rfid.Params;
using Com.Asreader.P3xu.Device.Type;
using Com.Asreader.P3xu.Device;

namespace AsReaderP3xUAndroidDemo.Platforms.Android
{
    public class AsReaderP3xUMAUIManager
    {
        public class MyAsReaderDeviceListener : Java.Lang.Object, IAsReaderP3xUEventListener
        {
            AsReaderP3xUCallback asReaderP3xUCallback = AsReaderP3xUCallback.sharedInstance();
            public MyAsReaderDeviceListener()
            {

            }

            public void OnAccessResult(AsReaderP3xU p0, AsReaderP3xUResultCode p1, AsReaderP3xUActionState p2, string p3, string p4)
            {
                if (asReaderP3xUCallback.OnAccessResult != null)
                {
                    asReaderP3xUCallback.OnAccessResult(p0, p1, p2, p3, p4);
                }
            }

            public void OnActionChanged(AsReaderP3xU p0, AsReaderP3xUActionState p1)
            {
                if (asReaderP3xUCallback.OnActionChanged != null)
                {
                    asReaderP3xUCallback.OnActionChanged(p0, p1);
                }
            }

            public void OnKeyEvent(AsReaderP3xU p0, AsReaderP3xUKeyType p1, AsReaderP3xUKeyState p2)
            {
                if (asReaderP3xUCallback.OnKeyEvent != null)
                {
                    asReaderP3xUCallback.OnKeyEvent(p0, p1, p2);
                }
            }

            public void OnReadTag(AsReaderP3xU p0, AsReaderP3xUActionState p1, string p2, float p3)
            {
                if (asReaderP3xUCallback.OnReadTag != null)
                {
                    asReaderP3xUCallback.OnReadTag(p0, p1, p2, p3);
                }
            }

            public void OnStateChanged(AsReaderP3xU p0, AsReaderP3xUConnectionState p1)
            {
                if (p1 == AsReaderP3xUConnectionState.Connected)
                {
                    AsReaderP3xUMAUIManager.sharedInstance().isConnect = true;
                }
                else
                {
                    AsReaderP3xUMAUIManager.sharedInstance().isConnect = false;
                }
                if (asReaderP3xUCallback.OnStateChanged != null)
                {
                    asReaderP3xUCallback.OnStateChanged(p0, p1);
                }
            }
        }

        public AsReaderP3xU mAsReaderP3xU;
        public AsReaderP3xUDevice mDevice;
        public AsReaderP3xUDeviceUsbCdc usbCdc;
        private MyAsReaderDeviceListener myAsReaderDeviceListener;
        private int max;
        public  bool isConnect;

        static AsReaderP3xUMAUIManager uniqueInstance;
        static readonly object locker = new object();
        public static AsReaderP3xUMAUIManager sharedInstance()
        {
            if (uniqueInstance == null)
            {
                lock (locker)
                {
                    if (uniqueInstance == null)
                    {
                        uniqueInstance = new AsReaderP3xUMAUIManager();
                    }
                }
            }
            return uniqueInstance;
        }
        public AsReaderP3xUMAUIManager()
        {
            isConnect = false;
            mAsReaderP3xU = AsReaderP3xUManager.Instance;
            myAsReaderDeviceListener = new MyAsReaderDeviceListener();
            mAsReaderP3xU.SetEventListener(myAsReaderDeviceListener);
        }
        public void SetContext()
        {
            usbCdc = new AsReaderP3xUDeviceUsbCdc(MainActivity.Instance);
        }
        public void ConnectDevice()
        {
            mDevice = mAsReaderP3xU.CurrentDevice;
            if (mDevice == null)
            {
                mDevice = usbCdc;
            }
            mAsReaderP3xU.ConnectDevice(usbCdc);
        }
        public void DisconnectDevice()
        {
            if (mDevice != null)
            {
                mAsReaderP3xU.DisconnectDevice();
            }
        }
        public int PowerGain
        {
            get
            {
                if (GetAsReaderStatus() == false)
                {
                    return 5;
                }
                return mAsReaderP3xU.PowerGain;
            }
            set
            {
                if (GetAsReaderStatus() == false)
                {
                    return;
                }
                mAsReaderP3xU.PowerGain = value;
            }
        }
        [Obsolete]
        public string GetAPPVersion()
        {
            var activity = MainActivity.Instance;
            return activity.PackageManager.GetPackageInfo(activity.PackageName, 0).VersionName;
        }
        public string GetSDKVersion()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return AsReaderP3xUManager.Version;
            }
        }
        public string GetFirmwareVersion()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return mAsReaderP3xU.FirmwareVersion;
            }
        }
        public string GetRFModuleVersion()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return mAsReaderP3xU.RFModuleVersion;
            }
        }
        public string GetRegion()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return mAsReaderP3xU.Region;
            }
        }
        public string GetSerialNumber()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return mAsReaderP3xU.SerialNumber;
            }
        }
        public string GetHardwareNumber()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return mAsReaderP3xU.HardwareVersion;
            }
        }
        public void Inventory()
        {
            if (GetAsReaderStatus() == true)
            {
                mAsReaderP3xU.Inventory();
            }
        }
        public void Stop()
        {
            if (GetAsReaderStatus() == true)
            {
                mAsReaderP3xU.Stop();
            }
        }
        public ArrayList GetPowerGainRange()
        {
            ArrayList mList = new ArrayList();
            if (GetAsReaderStatus() == true)
            {
                AsReaderP3xUPowerRange powerRange = mAsReaderP3xU.PowerGainRange;
                int min = powerRange.Min / 10;
                max = powerRange.Max / 10;

                for (int i = min; i <= max; i += 1)
                {
                    mList.Add(i.ToString());
                }
            }
            return mList;
        }
        public int GetPowerRangeMax()
        {
            return max;
        }
        public void SetContinuousMode(bool enabled)
        {
            if (GetAsReaderStatus() == true)
            {
                mAsReaderP3xU.ContinuousMode = enabled;
            }
        }
        public void Destroy()
        {
            if (GetAsReaderStatus() == true)
            {
                AsReaderP3xUManager.OnDestroy();
                if (mDevice != null)
                {
                    mDevice.Destroy();
                    mDevice = null;
                }
            }
        }
        public bool GetAsReaderStatus()
        {
            if (mAsReaderP3xU != null && mDevice != null && mDevice.State == AsReaderP3xUConnectionState.Connected && isConnect)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        public string GetAsReaderP3xUSDKDLL()
        {
            return AsReaderP3xUSDKDLL.DLLVersion();
        }
    }
}

