﻿using Android;
using Android.App;
using Android.Content.PM;
using Android.OS;
using Android.Runtime;
using AndroidX.Core.App;
using AsReaderP3xUAndroidDemo.Platforms.Android;

namespace AsReaderP3xUAndroidDemo;

[Activity(Theme = "@style/Maui.SplashTheme", MainLauncher = true, ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation | ConfigChanges.UiMode | ConfigChanges.ScreenLayout | ConfigChanges.SmallestScreenSize | ConfigChanges.Density)]
public class MainActivity : MauiAppCompatActivity
{
    internal static MainActivity Instance { get; private set; }
    static readonly int REQUEST_TIRAMISU = 1000;
    static string[] PERMISSIONS_TIRAMISU = {
                Manifest.Permission.WakeLock,
                Manifest.Permission.ReadMediaImages,
                Manifest.Permission.ReadMediaVideo
        };
    static readonly int REQUEST = 2000;
    static string[] PERMISSIONS = {
                Manifest.Permission.WakeLock,
                Manifest.Permission.ReadExternalStorage,
                Manifest.Permission.WriteExternalStorage
        };
    AsReaderP3xUCallback asReaderP3xUAndroidDemo;
    protected override void OnCreate(Bundle savedInstanceState)
    {
        base.OnCreate(savedInstanceState);
        Instance = this;
        asReaderP3xUAndroidDemo = AsReaderP3xUCallback.sharedInstance();
        CheckPermission();
    }
    protected override void OnResume()
    {
        base.OnResume();
        if (asReaderP3xUAndroidDemo.OnReceivedDidBecomeActive != null)
        {
            asReaderP3xUAndroidDemo.OnReceivedDidBecomeActive(true);
        }
    }
    protected override void OnStop()
    {
        base.OnStop();
        if (asReaderP3xUAndroidDemo.OnReceivedDidBecomeActive != null)
        {
            asReaderP3xUAndroidDemo.OnReceivedDidBecomeActive(false);
        }
    }
    protected override void OnDestroy()
    {
        base.OnDestroy();
        AsReaderP3xUMAUIManager manager = AsReaderP3xUMAUIManager.sharedInstance();
        manager.Destroy();
    }
    public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Android.Content.PM.Permission[] grantResults)
    {
        if (requestCode == REQUEST_TIRAMISU)
        {
            bool status = true;
            for (int i = 0; i < grantResults.Length; i++)
            {
                if (grantResults[i] == Permission.Denied)
                {
                    status = false;
                    break;
                }
            }
            if (status == true)
            {
                initAsReaderManager();
            }
        }
        else if (requestCode == REQUEST)
        {
            bool status = true;
            for (int i = 0; i < grantResults.Length; i++)
            {
                if (grantResults[i] == Permission.Denied)
                {
                    status = false;
                    break;
                }
            }
            if (status == true)
            {
                initAsReaderManager();
            }
        }
    }
    private void CheckPermission()
    {
        if (Build.VERSION.SdkInt >= BuildVersionCodes.Tiramisu)
        {
            if (ActivityCompat.CheckSelfPermission(this, Manifest.Permission.WakeLock) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.ReadMediaImages) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.ReadMediaVideo) != (int)Permission.Granted)
            {
                ActivityCompat.RequestPermissions(this, PERMISSIONS_TIRAMISU, REQUEST_TIRAMISU);
            }
            else
            {
                initAsReaderManager();
            }
        }
        else
        {
            if (ActivityCompat.CheckSelfPermission(this, Manifest.Permission.WakeLock) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.ReadExternalStorage) != (int)Permission.Granted
            || ActivityCompat.CheckSelfPermission(this, Manifest.Permission.WriteExternalStorage) != (int)Permission.Granted)
            {
                ActivityCompat.RequestPermissions(this, PERMISSIONS, REQUEST);
            }
            else
            {
                initAsReaderManager();
            }
        }
    }
    private void initAsReaderManager()
    {
        AsReaderP3xUMAUIManager manager = AsReaderP3xUMAUIManager.sharedInstance();
        manager.SetContext();
    }
}

